diff --git a/src/backend/replication/logical/applyparallelworker.c b/src/backend/replication/logical/applyparallelworker.c
new file mode 100644
index 0000000..ec48a94
--- /dev/null
+++ b/src/backend/replication/logical/applyparallelworker.c
@@ -0,0 +1,1328 @@
+/*-------------------------------------------------------------------------
+ * applyparallelworker.c
+ *	   Support routines for applying xact by parallel apply worker
+ *
+ * Copyright (c) 2022, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  src/backend/replication/logical/applyparallelworker.c
+ *
+ * This file contains routines that are intended to support setting up, using,
+ * and tearing down a ParallelApplyWorkerInfo.
+ *
+ * Refer to the comments in the file header of logical/worker.c to see more
+ * information about parallel apply workers.
+ *
+ * Deadlock-detection
+ * ------------------
+ * Since the database structure (schema of subscription tables, etc.) of
+ * publisher and subscriber may be different, applying transactions in parallel
+ * mode on the subscriber side may cause some deadlock problems that do not
+ * occur on the publisher side.
+ *
+ * Suppose a subscribed table does not have a unique key on the publisher and
+ * has a unique key on the subscriber.
+ *
+ * 1) Deadlock between the leader apply worker and a parallel apply worker
+ *
+ * The parallel apply worker (PA) is executing TX-1 and the leader apply worker
+ * (LA) is executing TX-2 concurrently on the subscriber. Now, LA is waiting
+ * for PA because of the unique key of the subscribed table while PA is waiting
+ * for LA to send further messages.
+ *
+ * In order for lmgr to detect this, we have LA acquire a session lock on the
+ * remote transaction (by pa_lock_stream()) and have PA wait on the lock before
+ * trying to receive messages. In other words, LA acquires the lock before
+ * sending STREAM_STOP and releases it if already acquired before sending
+ * STREAM_START, STREAM_ABORT (for toplevel transaction), STREAM_PREPARE and
+ * STREAM_COMMIT. For PA, it always needs to acquire the lock after processing
+ * STREAM_STOP and STREAM_ABORT (for subtransaction) and then release
+ * immediately after acquiring it. That way, when PA is waiting for LA, we can
+ * have a wait-edge from PA to LA in lmgr, which will make a deadlock in lmgr
+ * like:
+ *
+ * LA (waiting to acquire the lock on the unique index) -> PA (waiting to
+ * acquire the lock on the remote transaction) -> LA
+ *
+ * 2) Deadlock between the leader apply worker and parallel apply workers
+ *
+ * This scenario is similar to the first case but TX-1 and TX-2 are executed by
+ * two parallel apply workers (PA-1 and PA-2 respectively). In this scenario,
+ * PA-2 is waiting for PA-1 to complete its transaction while PA-1 is waiting
+ * for subsequent input from LA. Also, LA is waiting for PA-2 to complete its
+ * transaction in order to preserve the commit order. There is a deadlock among
+ * three processes.
+ *
+ * In order for lmgr to detect this, we have PA acquire a session lock on the
+ * transaction being applied and have LA wait on the lock before proceeding in
+ * transaction finish commands. That way, we can have a wait-edge from LA to PA
+ * in lmgr, which will make a deadlock in lmgr like:
+ *
+ * LA (waiting to acquire the local transaction lock) -> PA-1 (waiting to
+ * acquire the lock on the unique index) -> PA-2 (waiting to acquire the lock
+ * on the remote transaction) -> LA
+ *
+ * One might think we can use XactLockTableWait(), but XactLockTableWait()
+ * considers PREPARED TRANSACTION as still in progress which means the lock
+ * won't be released even if the parallel apply worker prepared the transaction.
+ *
+ * 3) deadlock when the shm_mq buffer is full
+ *
+ * The scenario where LA has to wait is when the shm_mq buffer is full. In the
+ * above scenario (ie. PA-1 and PA-2 are executing transactions concurrently),
+ * if the shm_mq buffer between LA and PA-2 is full, LA has to wait to send
+ * messages, and this wait doesn't appear in lmgr.
+ *
+ * To resolve this issue, we use non-blocking write and wait with a timeout. If
+ * timeout is exceeded, the LA reports an error and restarts logical
+ * replication.
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "libpq/pqformat.h"
+#include "libpq/pqmq.h"
+#include "pgstat.h"
+#include "postmaster/interrupt.h"
+#include "replication/logicallauncher.h"
+#include "replication/logicalworker.h"
+#include "replication/origin.h"
+#include "replication/worker_internal.h"
+#include "storage/ipc.h"
+#include "storage/lmgr.h"
+#include "tcop/tcopprot.h"
+#include "utils/inval.h"
+#include "utils/memutils.h"
+#include "utils/syscache.h"
+
+#define PG_LOGICAL_APPLY_SHM_MAGIC 0x787ca067
+
+/*
+ * DSM keys for parallel apply worker.  Unlike other parallel execution code,
+ * since we don't need to worry about DSM keys conflicting with plan_node_id we
+ * can use small integers.
+ */
+#define PARALLEL_APPLY_KEY_SHARED		1
+#define PARALLEL_APPLY_KEY_MQ			2
+#define PARALLEL_APPLY_KEY_ERROR_QUEUE	3
+
+/* Queue size of DSM, 16 MB for now. */
+#define DSM_QUEUE_SIZE	(16 * 1024 * 1024)
+
+/*
+ * Error queue size of DSM. It is desirable to make it large enough that a
+ * typical ErrorResponse can be sent without blocking.  That way, a worker that
+ * errors out can write the whole message into the queue and terminate without
+ * waiting for the user backend.
+ */
+#define DSM_ERROR_QUEUE_SIZE			(16 * 1024)
+
+/*
+ * There are three fields in each message received by the parallel apply
+ * worker: start_lsn, end_lsn and send_time. Because we have updated these
+ * statistics in the leader apply worker, we can ignore these fields in the
+ * parallel apply worker (see function LogicalRepApplyLoop).
+ */
+#define SIZE_STATS_MESSAGE (2 * sizeof(XLogRecPtr) + sizeof(TimestampTz))
+
+/*
+ * The type of session-level lock on a transaction being applied on a logical
+ * replication subscriber.
+ */
+#define PARALLEL_APPLY_LOCK_STREAM	0
+#define PARALLEL_APPLY_LOCK_XACT	1
+
+/*
+ * Hash table entry to map xid to the parallel apply worker state.
+ */
+typedef struct ParallelApplyWorkerEntry
+{
+	TransactionId xid;			/* Hash key -- must be first */
+	ParallelApplyWorkerInfo *winfo;
+} ParallelApplyWorkerEntry;
+
+/* Parallel apply workers hash table (initialized on first use). */
+static HTAB *ParallelApplyWorkersHash = NULL;
+
+/*
+ * A list to maintain the active parallel apply workers. The information for
+ * the new worker is added to the list after successfully launching it. The
+ * list entry is removed at the end of the transaction if there are already
+ * enough workers in the worker pool. For more information about the worker
+ * pool, see comments atop worker.c.
+ */
+static List *ParallelApplyWorkersList = NIL;
+
+/*
+ * Information shared between leader apply worker and parallel apply worker.
+ */
+ParallelApplyWorkerShared *MyParallelShared = NULL;
+
+/*
+ * Is there a message sent by a parallel apply worker that the leader apply
+ * worker needs to receive?
+ */
+volatile sig_atomic_t ParallelApplyMessagePending = false;
+
+/*
+ * Cache the parallel apply worker information required for applying the
+ * current streaming transaction. It is used to save the cost of searching the
+ * hash table when applying the changes between STREAM_START and STREAM_STOP.
+ */
+ParallelApplyWorkerInfo *stream_apply_worker = NULL;
+
+/* A list to maintain subtransactions, if any. */
+List	   *subxactlist = NIL;
+
+static bool pa_can_start(TransactionId xid);
+static bool pa_setup_dsm(ParallelApplyWorkerInfo *winfo);
+static ParallelApplyWorkerInfo *pa_init_and_launch_worker(void);
+static ParallelApplyWorkerInfo *pa_get_available_worker(void);
+static void pa_free_worker_info(ParallelApplyWorkerInfo *winfo);
+static ParallelTransState pa_get_xact_state(ParallelApplyWorkerShared *wshared);
+
+/*
+ * Returns true if it is OK to start a parallel apply worker, false otherwise.
+ */
+static bool
+pa_can_start(TransactionId xid)
+{
+	Assert(TransactionIdIsValid(xid));
+
+	/*
+	 * Don't start a new parallel apply worker if the subscription is not
+	 * using parallel streaming mode, or if the publisher does not support
+	 * parallel apply.
+	 */
+	if (!MyLogicalRepWorker->parallel_apply)
+		return false;
+
+	/* Only leader apply workers can start parallel apply workers. */
+	if (!am_leader_apply_worker())
+		return false;
+
+	/*
+	 * Don't start a new parallel worker if user has set skiplsn as it's
+	 * possible that user want to skip the streaming transaction. For
+	 * streaming transaction, we need to spill the transaction to disk so that
+	 * we can get the last LSN of the transaction to judge whether to skip
+	 * before starting to apply the change.
+	 */
+	if (!XLogRecPtrIsInvalid(MySubscription->skiplsn))
+		return false;
+
+	/*
+	 * For streaming transactions that are being applied using a parallel
+	 * apply worker, we cannot decide whether to apply the change for a
+	 * relation that is not in the READY state (see
+	 * should_apply_changes_for_rel) as we won't know remote_final_lsn by that
+	 * time. So, we don't start the new parallel apply worker in this case.
+	 */
+	if (!AllTablesyncsReady())
+		return false;
+
+	return true;
+}
+
+/*
+ * Get an available parallel apply worker from the worker pool.
+ */
+static ParallelApplyWorkerInfo *
+pa_get_available_worker(void)
+{
+	List	   *active_workers = list_copy(ParallelApplyWorkersList);
+	ListCell   *lc;
+
+	foreach(lc, active_workers)
+	{
+		ParallelApplyWorkerInfo *winfo;
+
+		winfo = (ParallelApplyWorkerInfo *) lfirst(lc);
+
+		/*
+		 * We first try to free the worker to improve our chances of finding
+		 * one that is not in use. Normally, we free the worker after ensuring
+		 * that the transaction is committed by the parallel worker but for
+		 * rollbacks, we don't wait for the transaction to finish so can't free
+		 * the worker information immediately.
+		 */
+		if (pa_free_worker(winfo, winfo->shared->xid))
+			continue;
+
+		if (!winfo->in_use)
+			return winfo;
+	}
+
+	return NULL;
+}
+
+/*
+ * Allocate a parallel apply worker that will be used for the specified xid.
+ *
+ * We first try to get an available worker from the pool, if any and then try
+ * to launch a new worker. On successful allocation, remember the worker
+ * information in the hash table so that we can get it later for processing the
+ * streaming changes.
+ */
+void
+pa_allocate_worker(TransactionId xid)
+{
+	bool		found;
+	ParallelApplyWorkerInfo *winfo = NULL;
+	ParallelApplyWorkerEntry *entry;
+
+	if (!pa_can_start(xid))
+		return;
+
+	/* First time through, initialize apply workers hashtable. */
+	if (!ParallelApplyWorkersHash)
+	{
+		HASHCTL		ctl;
+
+		MemSet(&ctl, 0, sizeof(ctl));
+		ctl.keysize = sizeof(TransactionId);
+		ctl.entrysize = sizeof(ParallelApplyWorkerEntry);
+		ctl.hcxt = ApplyContext;
+
+		ParallelApplyWorkersHash = hash_create("logical replication parallel apply workers hash",
+											   16, &ctl,
+											   HASH_ELEM | HASH_BLOBS | HASH_CONTEXT);
+	}
+
+	/* First, try to get a parallel apply worker from the pool. */
+	winfo = pa_get_available_worker();
+
+	if (!winfo)
+	{
+		/* Try to start a new parallel apply worker. */
+		winfo = pa_init_and_launch_worker();
+
+		if (!winfo)
+			return;
+	}
+
+	/* Create an entry for the requested transaction. */
+	entry = hash_search(ParallelApplyWorkersHash, &xid, HASH_ENTER, &found);
+	if (found)
+		elog(ERROR, "hash table corrupted");
+
+	/* Initialize shared memory area. */
+	SpinLockAcquire(&winfo->shared->mutex);
+	winfo->shared->xact_state = PARALLEL_TRANS_UNKNOWN;
+	winfo->shared->xid = xid;
+	SpinLockRelease(&winfo->shared->mutex);
+
+	winfo->in_use = true;
+	entry->winfo = winfo;
+	entry->xid = xid;
+}
+
+/*
+ * Find the assigned worker for the given transaction, if any.
+ */
+ParallelApplyWorkerInfo *
+pa_find_worker(TransactionId xid)
+{
+	bool		found;
+	ParallelApplyWorkerEntry *entry;
+
+	if (!TransactionIdIsValid(xid))
+		return NULL;
+
+	if (!ParallelApplyWorkersHash)
+		return NULL;
+
+	/* Return the cached parallel apply worker if valid. */
+	if (stream_apply_worker)
+		return stream_apply_worker;
+
+	/* Find an entry for the requested transaction. */
+	entry = hash_search(ParallelApplyWorkersHash, &xid, HASH_FIND, &found);
+	if (found)
+	{
+		/* The worker must not have exited.  */
+		Assert(entry->winfo->in_use);
+		return entry->winfo;
+	}
+
+	return NULL;
+}
+
+/*
+ * Makes the worker available for reuse.
+ *
+ * This removes the parallel apply worker entry from the hash table so that it
+ * can't be used. If there are enough workers in the pool, it stops the worker
+ * and frees the corresponding info. Otherwise it just marks the worker as
+ * available for reuse.
+ *
+ * For more information about the worker pool, see comments atop worker.c.
+ *
+ * Returns true if the worker is stopped, false otherwise.
+ */
+bool
+pa_free_worker(ParallelApplyWorkerInfo *winfo, TransactionId xid)
+{
+	int			napplyworkers;
+
+	Assert(!am_parallel_apply_worker());
+
+	/* Worker is already available for reuse. */
+	if (!winfo->in_use)
+		return false;
+
+	/*
+	 * Don't free the worker if the transaction in the worker is still in
+	 * progress. This could happen as we don't wait for the apply of rollback
+	 * to finish.
+	 */
+	if (pa_get_xact_state(winfo->shared) != PARALLEL_TRANS_FINISHED)
+		return false;
+
+	if (!hash_search(ParallelApplyWorkersHash, &xid, HASH_REMOVE, NULL))
+		elog(ERROR, "hash table corrupted");
+
+	LWLockAcquire(LogicalRepWorkerLock, LW_SHARED);
+	napplyworkers = logicalrep_pa_worker_count(MyLogicalRepWorker->subid);
+	LWLockRelease(LogicalRepWorkerLock);
+
+	/* Stop the worker if there are enough workers in the pool. */
+	if (napplyworkers > (max_parallel_apply_workers_per_subscription / 2))
+	{
+		int			slot_no;
+		uint16		generation;
+
+		SpinLockAcquire(&winfo->shared->mutex);
+		generation = winfo->shared->logicalrep_worker_generation;
+		slot_no = winfo->shared->logicalrep_worker_slot_no;
+		SpinLockRelease(&winfo->shared->mutex);
+
+		logicalrep_pa_worker_stop(slot_no, generation);
+
+		pa_free_worker_info(winfo);
+
+		return true;
+	}
+
+	winfo->in_use = false;
+
+	return false;
+}
+
+/* Free the parallel apply worker information. */
+static void
+pa_free_worker_info(ParallelApplyWorkerInfo *winfo)
+{
+	Assert(winfo);
+
+	if (winfo->mq_handle)
+		shm_mq_detach(winfo->mq_handle);
+
+	if (winfo->error_mq_handle)
+		shm_mq_detach(winfo->error_mq_handle);
+
+	if (winfo->dsm_seg)
+		dsm_detach(winfo->dsm_seg);
+
+	ParallelApplyWorkersList = list_delete_ptr(ParallelApplyWorkersList,
+											   winfo);
+
+	pfree(winfo);
+}
+
+/*
+ * Interrupt handler for main loops of parallel apply worker.
+ */
+static void
+ProcessParallelApplyInterrupts(void)
+{
+	CHECK_FOR_INTERRUPTS();
+
+	if (ShutdownRequestPending)
+	{
+		ereport(LOG,
+				(errmsg("logical replication parallel apply worker for subscription \"%s\" has finished",
+				 MySubscription->name)));
+
+		apply_worker_clean_exit();
+	}
+
+	if (ConfigReloadPending)
+	{
+		ConfigReloadPending = false;
+		ProcessConfigFile(PGC_SIGHUP);
+	}
+}
+
+/* Parallel apply worker main loop. */
+static void
+LogicalParallelApplyLoop(shm_mq_handle *mqh)
+{
+	shm_mq_result shmq_res;
+	ErrorContextCallback errcallback;
+	MemoryContext oldcxt = CurrentMemoryContext;
+
+	/*
+	 * Init the ApplyMessageContext which we clean up after each replication
+	 * protocol message.
+	 */
+	ApplyMessageContext = AllocSetContextCreate(ApplyContext,
+												"ApplyMessageContext",
+												ALLOCSET_DEFAULT_SIZES);
+
+	/*
+	 * Push apply error context callback. Fields will be filled while applying
+	 * a change.
+	 */
+	errcallback.callback = apply_error_callback;
+	errcallback.previous = error_context_stack;
+	error_context_stack = &errcallback;
+
+	for (;;)
+	{
+		void	   *data;
+		Size		len;
+
+		ProcessParallelApplyInterrupts();
+
+		/* Ensure we are reading the data into our memory context. */
+		MemoryContextSwitchTo(ApplyMessageContext);
+
+		shmq_res = shm_mq_receive(mqh, &len, &data, true);
+
+		if (shmq_res == SHM_MQ_SUCCESS)
+		{
+			StringInfoData s;
+			int			c;
+
+			if (len == 0)
+				break;
+
+			s.cursor = 0;
+			s.maxlen = -1;
+			s.data = (char *) data;
+			s.len = len;
+
+			/*
+			 * The first byte of messages sent from leader apply worker to
+			 * parallel apply workers can only be 'w'.
+			 */
+			c = pq_getmsgbyte(&s);
+			if (c != 'w')
+				elog(ERROR, "unexpected message \"%c\"", c);
+
+			/*
+			 * Ignore statistics fields that have been updated by the leader
+			 * apply worker.
+			 */
+			s.cursor += SIZE_STATS_MESSAGE;
+
+			apply_dispatch(&s);
+
+			MemoryContextReset(ApplyMessageContext);
+		}
+		else if (shmq_res == SHM_MQ_WOULD_BLOCK)
+		{
+			int			rc;
+
+			if (!in_streamed_transaction)
+			{
+				/*
+				 * If we didn't get any transactions for a while there might
+				 * be unconsumed invalidation messages in the queue, consume
+				 * them now.
+				 */
+				AcceptInvalidationMessages();
+				maybe_reread_subscription();
+			}
+
+			MemoryContextReset(ApplyMessageContext);
+			MemoryContextSwitchTo(oldcxt);
+
+			/* Wait for more work. */
+			rc = WaitLatch(MyLatch,
+						   WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+						   1000L,
+						   WAIT_EVENT_LOGICAL_PARALLEL_APPLY_MAIN);
+
+			if (rc & WL_LATCH_SET)
+			{
+				ResetLatch(MyLatch);
+				ProcessParallelApplyInterrupts();
+			}
+		}
+		else
+		{
+			Assert(shmq_res == SHM_MQ_DETACHED);
+
+			ereport(ERROR,
+					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+					 errmsg("lost connection to the logical replication apply worker")));
+		}
+	}
+
+	/* Pop the error context stack. */
+	error_context_stack = errcallback.previous;
+
+	MemoryContextSwitchTo(oldcxt);
+}
+
+/*
+ * Make sure the leader apply worker tries to read from our error queue one more
+ * time. This guards against the case where we exit uncleanly without sending
+ * an ErrorResponse, for example because some code calls proc_exit directly.
+ */
+static void
+pa_shutdown(int code, Datum arg)
+{
+	SendProcSignal(MyLogicalRepWorker->apply_leader_pid,
+				   PROCSIG_PARALLEL_APPLY_MESSAGE,
+				   InvalidBackendId);
+
+	dsm_detach((dsm_segment *) DatumGetPointer(arg));
+}
+
+/*
+ * Parallel apply worker entry point.
+ */
+void
+ParallelApplyWorkerMain(Datum main_arg)
+{
+	ParallelApplyWorkerShared *shared;
+	dsm_handle	handle;
+	dsm_segment *seg;
+	shm_toc    *toc;
+	shm_mq	   *mq;
+	shm_mq_handle *mqh;
+	shm_mq_handle *error_mqh;
+	RepOriginId originid;
+	int			worker_slot = DatumGetInt32(main_arg);
+	char		originname[NAMEDATALEN];
+
+	/* Setup signal handling. */
+	pqsignal(SIGHUP, SignalHandlerForConfigReload);
+	pqsignal(SIGINT, SignalHandlerForShutdownRequest);
+	pqsignal(SIGTERM, die);
+	BackgroundWorkerUnblockSignals();
+
+	/*
+	 * Attach to the dynamic shared memory segment for the parallel apply, and
+	 * find its table of contents.
+	 *
+	 * Like parallel query, we don't need resource owner by this time. See
+	 * ParallelWorkerMain.
+	 */
+	memcpy(&handle, MyBgworkerEntry->bgw_extra, sizeof(dsm_handle));
+	seg = dsm_attach(handle);
+	if (!seg)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("unable to map dynamic shared memory segment")));
+
+	toc = shm_toc_attach(PG_LOGICAL_APPLY_SHM_MAGIC, dsm_segment_address(seg));
+	if (!toc)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("bad magic number in dynamic shared memory segment")));
+
+	before_shmem_exit(pa_shutdown, PointerGetDatum(seg));
+
+	/* Look up the shared information. */
+	shared = shm_toc_lookup(toc, PARALLEL_APPLY_KEY_SHARED, false);
+	MyParallelShared = shared;
+
+	/*
+	 * Attach to the message queue.
+	 */
+	mq = shm_toc_lookup(toc, PARALLEL_APPLY_KEY_MQ, false);
+	shm_mq_set_receiver(mq, MyProc);
+	mqh = shm_mq_attach(mq, seg, NULL);
+
+	/*
+	 * Primary initialization is complete. Now, we can attach to our slot.
+	 * This is to ensure that the leader apply worker does not write data to
+	 * the uninitialized memory queue.
+	 */
+	logicalrep_worker_attach(worker_slot);
+
+	SpinLockAcquire(&MyParallelShared->mutex);
+	MyParallelShared->logicalrep_worker_generation = MyLogicalRepWorker->generation;
+	MyParallelShared->logicalrep_worker_slot_no = worker_slot;
+	SpinLockRelease(&MyParallelShared->mutex);
+
+	/*
+	 * Attach to the error queue.
+	 */
+	mq = shm_toc_lookup(toc, PARALLEL_APPLY_KEY_ERROR_QUEUE, false);
+	shm_mq_set_sender(mq, MyProc);
+	error_mqh = shm_mq_attach(mq, seg, NULL);
+
+	pq_redirect_to_shm_mq(seg, error_mqh);
+	pq_set_parallel_leader(MyLogicalRepWorker->apply_leader_pid,
+						   InvalidBackendId);
+
+	MyLogicalRepWorker->last_send_time = MyLogicalRepWorker->last_recv_time =
+		MyLogicalRepWorker->reply_time = 0;
+
+	InitializeApplyWorker();
+
+	/* Setup replication origin tracking. */
+	StartTransactionCommand();
+	ReplicationOriginNameForLogicalRep(MySubscription->oid, InvalidOid,
+									   originname, sizeof(originname));
+	originid = replorigin_by_name(originname, true);
+	if (!OidIsValid(originid))
+		originid = replorigin_create(originname);
+
+	/*
+	 * The parallel apply worker doesn't need to monopolize this replication
+	 * origin which was already acquired by its leader process.
+	 */
+	replorigin_session_setup(originid, MyLogicalRepWorker->apply_leader_pid);
+	replorigin_session_origin = originid;
+	CommitTransactionCommand();
+
+	/*
+	 * Setup callback for syscache so that we know when something changes in
+	 * the subscription relation state.
+	 */
+	CacheRegisterSyscacheCallback(SUBSCRIPTIONRELMAP,
+								  invalidate_syncing_table_states,
+								  (Datum) 0);
+
+	/*
+	 * Allocate the origin name in a long-lived context for error context
+	 * message.
+	 */
+	apply_error_callback_arg.origin_name = MemoryContextStrdup(ApplyContext,
+															   originname);
+
+	LogicalParallelApplyLoop(mqh);
+
+	apply_worker_clean_exit();
+}
+
+/*
+ * Handle receipt of an interrupt indicating a parallel apply worker message.
+ *
+ * Note: this is called within a signal handler! All we can do is set a flag
+ * that will cause the next CHECK_FOR_INTERRUPTS() to invoke
+ * HandleParallelApplyMessages().
+ */
+void
+HandleParallelApplyMessageInterrupt(void)
+{
+	InterruptPending = true;
+	ParallelApplyMessagePending = true;
+	SetLatch(MyLatch);
+}
+
+/*
+ * Handle a single protocol message received from a single parallel apply
+ * worker.
+ */
+static void
+HandleParallelApplyMessage(ParallelApplyWorkerInfo *winfo, StringInfo msg)
+{
+	char		msgtype;
+
+	msgtype = pq_getmsgbyte(msg);
+
+	switch (msgtype)
+	{
+		case 'E':				/* ErrorResponse */
+			{
+				ErrorData	edata;
+
+				/* Parse ErrorResponse. */
+				pq_parse_errornotice(msg, &edata);
+
+				/*
+				 * If desired, add a context line to show that this is a
+				 * message propagated from a parallel apply worker. Otherwise,
+				 * it can sometimes be confusing to understand what actually
+				 * happened.
+				 */
+				if (edata.context)
+					edata.context = psprintf("%s\n%s", edata.context,
+											 _("logical replication parallel apply worker"));
+				else
+					edata.context = pstrdup(_("logical replication parallel apply worker"));
+
+				/*
+				 * Context beyond that should use the error context callbacks
+				 * that were in effect in LogicalRepApplyLoop().
+				 */
+				error_context_stack = apply_error_context_stack;
+
+				ereport(ERROR,
+						(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+						 errmsg("logical replication parallel apply worker exited abnormally"),
+						 errcontext("%s", edata.context)));
+			}
+
+			/*
+			 * Don't need to do anything about NoticeResponse and
+			 * NotifyResponse as the logical replication worker doesn't need
+			 * to send messages to the client.
+			 */
+		case 'N':
+		case 'A':
+			break;
+
+		case 'X':				/* Terminate, indicating clean exit. */
+				shm_mq_detach(winfo->error_mq_handle);
+				winfo->error_mq_handle = NULL;
+				break;
+		default:
+			elog(ERROR, "unrecognized message type received from logical replication parallel apply worker: %c (message length %d bytes)",
+				 msgtype, msg->len);
+	}
+}
+
+/*
+ * Handle any queued protocol messages received from parallel apply workers.
+ */
+void
+HandleParallelApplyMessages(void)
+{
+	ListCell   *lc;
+	MemoryContext oldcontext;
+
+	static MemoryContext hpam_context = NULL;
+
+	/*
+	 * This is invoked from ProcessInterrupts(), and since some of the
+	 * functions it calls contain CHECK_FOR_INTERRUPTS(), there is a potential
+	 * for recursive calls if more signals are received while this runs. It's
+	 * unclear that recursive entry would be safe, and it doesn't seem useful
+	 * even if it is safe, so let's block interrupts until done.
+	 */
+	HOLD_INTERRUPTS();
+
+	/*
+	 * Moreover, CurrentMemoryContext might be pointing almost anywhere. We
+	 * don't want to risk leaking data into long-lived contexts, so let's do
+	 * our work here in a private context that we can reset on each use.
+	 */
+	if (!hpam_context)	/* first time through? */
+		hpam_context = AllocSetContextCreate(TopMemoryContext,
+											 "HandleParallelApplyMessages",
+											 ALLOCSET_DEFAULT_SIZES);
+	else
+		MemoryContextReset(hpam_context);
+
+	oldcontext = MemoryContextSwitchTo(hpam_context);
+
+	ParallelApplyMessagePending = false;
+
+	foreach(lc, ParallelApplyWorkersList)
+	{
+		shm_mq_result res;
+		Size		nbytes;
+		void	   *data;
+		ParallelApplyWorkerInfo *winfo = (ParallelApplyWorkerInfo *) lfirst(lc);
+
+		if (!winfo->error_mq_handle)
+			continue;
+
+		res = shm_mq_receive(winfo->error_mq_handle, &nbytes, &data, true);
+
+		if (res == SHM_MQ_WOULD_BLOCK)
+			continue;
+		else if (res == SHM_MQ_SUCCESS)
+		{
+			StringInfoData msg;
+
+			initStringInfo(&msg);
+			appendBinaryStringInfo(&msg, data, nbytes);
+			HandleParallelApplyMessage(winfo, &msg);
+			pfree(msg.data);
+		}
+		else
+			ereport(ERROR,
+					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+					 errmsg("lost connection to the logical replication parallel apply worker")));
+	}
+
+	MemoryContextSwitchTo(oldcontext);
+
+	/* Might as well clear the context on our way out */
+	MemoryContextReset(hpam_context);
+
+	RESUME_INTERRUPTS();
+}
+
+/*
+ * Set up a dynamic shared memory segment.
+ *
+ * We set up a control region that contains a fixed-size worker info
+ * (ParallelApplyWorkerShared), a message queue, and an error queue.
+ *
+ * Returns true on success, false on failure.
+ */
+static bool
+pa_setup_dsm(ParallelApplyWorkerInfo *winfo)
+{
+	shm_toc_estimator e;
+	Size		segsize;
+	dsm_segment *seg;
+	shm_toc    *toc;
+	ParallelApplyWorkerShared *shared;
+	shm_mq	   *mq;
+	Size		queue_size = DSM_QUEUE_SIZE;
+	Size		error_queue_size = DSM_ERROR_QUEUE_SIZE;
+
+	/*
+	 * Estimate how much shared memory we need.
+	 *
+	 * Because the TOC machinery may choose to insert padding of oddly-sized
+	 * requests, we must estimate each chunk separately.
+	 *
+	 * We need one key to register the location of the header, and two other
+	 * keys to track the locations of the message queue and the error message
+	 * queue.
+	 */
+	shm_toc_initialize_estimator(&e);
+	shm_toc_estimate_chunk(&e, sizeof(ParallelApplyWorkerShared));
+	shm_toc_estimate_chunk(&e, queue_size);
+	shm_toc_estimate_chunk(&e, error_queue_size);
+
+	shm_toc_estimate_keys(&e, 3);
+	segsize = shm_toc_estimate(&e);
+
+	/* Create the shared memory segment and establish a table of contents. */
+	seg = dsm_create(shm_toc_estimate(&e), 0);
+	if (!seg)
+		return false;
+
+	toc = shm_toc_create(PG_LOGICAL_APPLY_SHM_MAGIC, dsm_segment_address(seg),
+						 segsize);
+
+	/* Set up the header region. */
+	shared = shm_toc_allocate(toc, sizeof(ParallelApplyWorkerShared));
+	SpinLockInit(&shared->mutex);
+
+	shared->xact_state = PARALLEL_TRANS_UNKNOWN;
+	pg_atomic_init_u32(&(shared->pending_stream_count), 0);
+
+	shm_toc_insert(toc, PARALLEL_APPLY_KEY_SHARED, shared);
+
+	/* Set up message queue for the worker. */
+	mq = shm_mq_create(shm_toc_allocate(toc, queue_size), queue_size);
+	shm_toc_insert(toc, PARALLEL_APPLY_KEY_MQ, mq);
+	shm_mq_set_sender(mq, MyProc);
+
+	/* Attach the queue. */
+	winfo->mq_handle = shm_mq_attach(mq, seg, NULL);
+
+	/* Set up error queue for the worker. */
+	mq = shm_mq_create(shm_toc_allocate(toc, error_queue_size),
+					   error_queue_size);
+	shm_toc_insert(toc, PARALLEL_APPLY_KEY_ERROR_QUEUE, mq);
+	shm_mq_set_receiver(mq, MyProc);
+
+	/* Attach the queue. */
+	winfo->error_mq_handle = shm_mq_attach(mq, seg, NULL);
+
+	/* Return results to caller. */
+	winfo->dsm_seg = seg;
+	winfo->shared = shared;
+
+	return true;
+}
+
+/*
+ * Start parallel apply worker process and allocate shared memory for it.
+ */
+static ParallelApplyWorkerInfo *
+pa_init_and_launch_worker(void)
+{
+	MemoryContext oldcontext;
+	bool		launched;
+	ParallelApplyWorkerInfo *winfo;
+
+	/*
+	 * The worker info can be used for the entire duration of the worker so
+	 * create it in a permanent context.
+	 */
+	oldcontext = MemoryContextSwitchTo(ApplyContext);
+
+	winfo = (ParallelApplyWorkerInfo *) palloc0(sizeof(ParallelApplyWorkerInfo));
+
+	/* Setup shared memory. */
+	if (!pa_setup_dsm(winfo))
+	{
+		MemoryContextSwitchTo(oldcontext);
+		pfree(winfo);
+		return NULL;
+	}
+
+	launched = logicalrep_worker_launch(MyLogicalRepWorker->dbid,
+										MySubscription->oid,
+										MySubscription->name,
+										MyLogicalRepWorker->userid,
+										InvalidOid,
+										dsm_segment_handle(winfo->dsm_seg));
+
+	if (launched)
+	{
+		ParallelApplyWorkersList = lappend(ParallelApplyWorkersList, winfo);
+	}
+	else
+	{
+		pa_free_worker_info(winfo);
+		winfo = NULL;
+	}
+
+	MemoryContextSwitchTo(oldcontext);
+
+	return winfo;
+}
+
+/*
+ * Send the data to the specified parallel apply worker via shared-memory
+ * queue.
+ */
+void
+pa_send_data(ParallelApplyWorkerInfo *winfo, Size nbytes, const void *data)
+{
+	int			rc;
+	shm_mq_result result;
+	TimestampTz startTime = 0;
+
+	Assert(!IsTransactionState());
+
+#define SHM_SEND_RETRY_INTERVAL_MS 1000
+#define SHM_SEND_TIMEOUT_MS		10000
+
+	for (;;)
+	{
+		result = shm_mq_send(winfo->mq_handle, nbytes, data, true, true);
+
+		if (result == SHM_MQ_SUCCESS)
+			break;
+		else if (result == SHM_MQ_DETACHED)
+			ereport(ERROR,
+					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+					 errmsg("could not send data to shared-memory queue")));
+
+		Assert(result == SHM_MQ_WOULD_BLOCK);
+
+		if (startTime == 0)
+			startTime = GetCurrentTimestamp();
+
+		/* Wait before retrying. */
+		rc = WaitLatch(MyLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+					   SHM_SEND_RETRY_INTERVAL_MS,
+					   WAIT_EVENT_LOGICAL_PARALLEL_APPLY_STATE_CHANGE);
+
+		if (rc & WL_LATCH_SET)
+		{
+			ResetLatch(MyLatch);
+			CHECK_FOR_INTERRUPTS();
+		}
+
+		if (TimestampDifferenceExceeds(startTime, GetCurrentTimestamp(),
+									   SHM_SEND_TIMEOUT_MS))
+			ereport(ERROR,
+					(errcode(ERRCODE_CONNECTION_FAILURE),
+					 errmsg("terminating logical replication parallel apply worker due to timeout")));
+	}
+}
+
+/*
+ * Wait until the parallel apply worker's transaction state has reached or
+ * exceeded the given xact_state.
+ */
+static void
+pa_wait_for_xact_state(ParallelApplyWorkerInfo *winfo,
+					   ParallelTransState xact_state)
+{
+	for (;;)
+	{
+		if (!winfo->error_mq_handle)
+			ereport(ERROR,
+					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+					 errmsg("lost connection to the logical replication parallel apply worker")));
+
+		/*
+		 * Stop if the transaction state has reached or exceeded the given
+		 * xact_state.
+		 */
+		if (pa_get_xact_state(winfo->shared) >= xact_state)
+			break;
+
+		/* Wait to be signalled. */
+		(void) WaitLatch(MyLatch,
+						 WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+						 10L,
+						 WAIT_EVENT_LOGICAL_PARALLEL_APPLY_STATE_CHANGE);
+
+		/* Reset the latch so we don't spin. */
+		ResetLatch(MyLatch);
+
+		/* An interrupt may have occurred while we were waiting. */
+		CHECK_FOR_INTERRUPTS();
+	}
+}
+
+/*
+ * Wait until the parallel apply worker's transaction finishes.
+ */
+void
+pa_wait_for_xact_finish(ParallelApplyWorkerInfo *winfo)
+{
+	/*
+	 * Wait until the parallel apply worker set the state to
+	 * PARALLEL_TRANS_STARTED which means it has acquired the transaction
+	 * lock. This is to prevent leader apply worker from acquiring the
+	 * transaction lock earlier than the parallel apply worker.
+	 */
+	pa_wait_for_xact_state(winfo, PARALLEL_TRANS_STARTED);
+
+	/*
+	 * Wait for the transaction lock to be released. This is required to detect
+	 * deadlock among leader and parallel apply workers. See comments atop this
+	 * file.
+	 */
+	pa_lock_transaction(winfo->shared->xid, AccessExclusiveLock);
+	pa_unlock_transaction(winfo->shared->xid, AccessExclusiveLock);
+
+	/*
+	 * Check if the state becomes PARALLEL_TRANS_FINISHED in case the parallel
+	 * apply worker failed while applying changes causing the lock to be
+	 * released.
+	 */
+	if (pa_get_xact_state(winfo->shared) != PARALLEL_TRANS_FINISHED)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("lost connection to the logical replication parallel apply worker")));
+}
+
+/*
+ * Set an enum indicating the transaction state for the given parallel apply
+ * worker.
+ */
+void
+pa_set_xact_state(ParallelApplyWorkerShared *wshared,
+				  ParallelTransState xact_state)
+{
+	SpinLockAcquire(&wshared->mutex);
+	wshared->xact_state = xact_state;
+	SpinLockRelease(&wshared->mutex);
+}
+
+/*
+ * Get an enum indicating the transaction state for the given parallel apply
+ * worker.
+ */
+static ParallelTransState
+pa_get_xact_state(ParallelApplyWorkerShared *wshared)
+{
+	ParallelTransState xact_state;
+
+	SpinLockAcquire(&wshared->mutex);
+	xact_state = wshared->xact_state;
+	SpinLockRelease(&wshared->mutex);
+
+	return xact_state;
+}
+
+/*
+ * Form a unique savepoint name for the streaming transaction.
+ *
+ * Note that different subscriptions for publications on different nodes can
+ * receive same remote xid, so we need to use subscription id along with it.
+ *
+ * Return the name in the supplied buffer.
+ */
+static void
+pa_savepoint_name(Oid suboid, TransactionId xid, char *spname, Size szsp)
+{
+	snprintf(spname, szsp, "pg_sp_%u_%u", suboid, xid);
+}
+
+/*
+ * Define a savepoint for a subxact in parallel apply worker if needed.
+ *
+ * The parallel apply worker can figure out if a new subtransaction was
+ * started by checking if the new change arrived with a different xid. In that
+ * case define a named savepoint, so that we are able to rollback to it
+ * if required.
+ */
+void
+pa_start_subtrans(TransactionId current_xid, TransactionId top_xid)
+{
+	if (current_xid != top_xid &&
+		!list_member_xid(subxactlist, current_xid))
+	{
+		MemoryContext oldctx;
+		char		spname[NAMEDATALEN];
+
+		pa_savepoint_name(MySubscription->oid, current_xid,
+						  spname, sizeof(spname));
+
+		elog(DEBUG1, "defining savepoint %s in logical replication parallel apply worker", spname);
+
+		/* We must be in transaction block to define the SAVEPOINT. */
+		if (!IsTransactionBlock())
+		{
+			if (!IsTransactionState())
+				StartTransactionCommand();
+
+			BeginTransactionBlock();
+			CommitTransactionCommand();
+		}
+
+		DefineSavepoint(spname);
+
+		/*
+		 * CommitTransactionCommand is needed to start a subtransaction after
+		 * issuing a SAVEPOINT inside a transaction block (see
+		 * StartSubTransaction()).
+		 */
+		CommitTransactionCommand();
+
+		oldctx = MemoryContextSwitchTo(TopTransactionContext);
+		subxactlist = lappend_xid(subxactlist, current_xid);
+		MemoryContextSwitchTo(oldctx);
+	}
+}
+
+/*
+ * Handle STREAM ABORT message when the transaction was applied in a parallel
+ * apply worker.
+ */
+void
+pa_stream_abort(LogicalRepStreamAbortData *abort_data)
+{
+	TransactionId xid = abort_data->xid;
+	TransactionId subxid = abort_data->subxid;
+
+	/*
+	 * Update origin state so we can restart streaming from correct position
+	 * in case of crash.
+	 */
+	replorigin_session_origin_lsn = abort_data->abort_lsn;
+	replorigin_session_origin_timestamp = abort_data->abort_time;
+
+	/*
+	 * If the two XIDs are the same, it's in fact abort of toplevel xact, so
+	 * just free the subxactlist.
+	 */
+	if (subxid == xid)
+	{
+		/*
+		 * Release the lock as we might be processing an empty streaming
+		 * transaction in which case the lock won't be released during
+		 * transaction rollback.
+		 */
+		pa_unlock_transaction(xid, AccessShareLock);
+
+		list_free(subxactlist);
+		subxactlist = NIL;
+
+		AbortCurrentTransaction();
+
+		if (IsTransactionBlock())
+		{
+			EndTransactionBlock(false);
+			CommitTransactionCommand();
+		}
+
+		pgstat_report_activity(STATE_IDLE, NULL);
+
+		pa_set_xact_state(MyParallelShared, PARALLEL_TRANS_FINISHED);
+	}
+	else
+	{
+		/* OK, so it's a subxact. Rollback to the savepoint. */
+		int			i;
+		char		spname[NAMEDATALEN];
+
+		pa_savepoint_name(MySubscription->oid, subxid, spname, sizeof(spname));
+
+		elog(DEBUG1, "rolling back to savepoint %s in logical replication parallel apply worker", spname);
+
+		/*
+		 * Search the subxactlist, determine the offset tracked for the
+		 * subxact, and truncate the list.
+		 *
+		 * Note that If it's an empty sub-transaction then we will not find the
+		 * subxid here.
+		 */
+		for (i = list_length(subxactlist) - 1; i >= 0; i--)
+		{
+			TransactionId xid_tmp = lfirst_xid(list_nth_cell(subxactlist, i));
+
+			if (xid_tmp == subxid)
+			{
+				RollbackToSavepoint(spname);
+				CommitTransactionCommand();
+				subxactlist = list_truncate(subxactlist, i + 1);
+				break;
+			}
+		}
+
+		pgstat_report_activity(STATE_IDLEINTRANSACTION, NULL);
+	}
+}
+
+/*
+ * Helper functions to acquire and release a lock for each stream block.
+ *
+ * Set locktag_field4 to PARALLEL_APPLY_LOCK_STREAM to indicate that it's a
+ * stream lock.
+ *
+ * Refer to the comments atop applyparallelworker.c to see how the stream lock
+ * is used.
+ */
+void
+pa_lock_stream(TransactionId xid, LOCKMODE lockmode)
+{
+	LockApplyTransactionForSession(MyLogicalRepWorker->subid, xid,
+								   PARALLEL_APPLY_LOCK_STREAM, lockmode);
+}
+
+void
+pa_unlock_stream(TransactionId xid, LOCKMODE lockmode)
+{
+	UnlockApplyTransactionForSession(MyLogicalRepWorker->subid, xid,
+									 PARALLEL_APPLY_LOCK_STREAM, lockmode);
+}
+
+/*
+ * Helper functions to acquire and release a lock for each local transaction
+ * apply.
+ *
+ * Set locktag_field4 to PARALLEL_APPLY_LOCK_XACT to indicate that it's a
+ * transaction lock.
+ *
+ * Note that all the callers must pass a remote transaction ID instead of a
+ * local transaction ID as xid. This is because the local transaction ID will
+ * only be assigned while applying the first change in the parallel apply but
+ * it's possible that the first change in the parallel apply worker is blocked
+ * by a concurrently executing transaction in another parallel apply worker. We
+ * can only communicate the local transaction id to the leader after applying
+ * the first change so it won't be able to wait after sending the xact finish
+ * command using this lock.
+ *
+ * Refer to the comments atop applyparallelworker.c to see how the transaction
+ * lock is used.
+ */
+void
+pa_lock_transaction(TransactionId xid, LOCKMODE lockmode)
+{
+	LockApplyTransactionForSession(MyLogicalRepWorker->subid, xid,
+								   PARALLEL_APPLY_LOCK_XACT, lockmode);
+}
+
+void
+pa_unlock_transaction(TransactionId xid, LOCKMODE lockmode)
+{
+	UnlockApplyTransactionForSession(MyLogicalRepWorker->subid, xid,
+									 PARALLEL_APPLY_LOCK_XACT, lockmode);
+}
